// Generated by CoffeeScript 1.9.3

/*
 * jQuery Bifröst v1.0.2
 * http://matiasgagliano.github.com/bifrost/
 *
 * Copyright 2014, Matías A. Gagliano.
 * Dual licensed under the MIT or GPLv3 licenses.
 * http://opensource.org/licenses/MIT
 * http://opensource.org/licenses/GPL-3.0
 *
 */

(function() {
  "use strict";
  var $, Bifrost, console, iframeId;

  $ = jQuery;

  console = window.console || {
    log: function() {}
  };

  iframeId = 0;

  Bifrost = (function() {
    function Bifrost(options1, originalOptions1, jqXHR1) {
      this.options = options1;
      this.originalOptions = originalOptions1;
      this.jqXHR = jqXHR1;
    }

    Bifrost.prototype.send = function(headers, completeCallback) {
      var clone, clones, data, dataType, fileInputs, form, i, iframe, iframeName, j, k, len, len1, meta, name, o, options, pair, ref, ref1, results, value;
      options = this.options;
      dataType = options.dataTypes[1];
      meta = options.headers === false ? false : {};
      if (meta) {
        meta['X-Requested-With'] = 'IFrame';
        meta['Accept'] = options.accepts[dataType];
        if (dataType !== '*') {
          meta['Accept'] += ', */*; q=0.01';
        }
      }
      if ((ref = options.method) === 'DELETE' || ref === 'PUT' || ref === 'PATCH') {
        if (meta) {
          meta['_method'] = options.method;
        }
        options.method = 'POST';
      }
      iframeId++;
      iframeName = "iframe-transport-" + iframeId;
      iframe = this.iframe = $('<iframe>').css('display', 'none');
      iframe.attr({
        name: iframeName,
        src: 'javascript:false;'
      });
      iframe.appendTo(document.body);
      iframe.one('load', function() {
        var error, response;
        try {
          response = iframe.contents() || $();
          completeCallback(200, 'success', {
            iframe: response
          });
        } catch (_error) {
          error = _error;
          console.log(error);
          completeCallback(403, 'error', {
            iframe: ''
          });
        }
        form.remove();
        iframe.detach();
        return iframe = null;
      });
      form = this.form = $('<form>').css('display', 'none');
      form.prop({
        target: iframeName,
        action: options.url,
        method: options.method
      });
      form.appendTo(document.body);
      data = this.originalOptions.data;
      if ($.isArray(data)) {
        o = {};
        for (j = 0, len = data.length; j < len; j++) {
          pair = data[j];
          ref1 = [pair.name, pair.value], name = ref1[0], value = ref1[1];
          if (o[name] === void 0) {
            o[name] = value;
          } else if ($.isArray(o[name])) {
            o[name].push(value);
          } else {
            o[name] = [o[name], value];
          }
        }
        data = o;
      }
      if (meta) {
        data = $.extend({}, meta, options.headers || {}, data);
      }
      for (name in data) {
        value = data[name];
        form.append($('<input>').attr({
          type: 'hidden',
          name: name,
          value: value
        }));
      }
      fileInputs = $(options.fileInputs);
      clones = $();
      if (options.method === 'POST' && fileInputs.length) {
        form.prop({
          enctype: 'multipart/form-data',
          encoding: 'multipart/form-data'
        });
        clones = fileInputs.clone().prop('disabled', true);
        fileInputs.after(function(index) {
          return clones[index];
        });
        form.append(fileInputs);
      }
      form.submit();
      results = [];
      for (i = k = 0, len1 = clones.length; k < len1; i = ++k) {
        clone = clones[i];
        results.push($(clone).replaceWith(fileInputs[i]));
      }
      return results;
    };

    Bifrost.prototype.abort = function() {
      if (this.form) {
        this.form.remove();
      }
      if (this.iframe) {
        return this.iframe.off('load');
      }
    };

    return Bifrost;

  })();

  $.ajaxTransport('iframe', function(options, originalOptions, jqXHR) {
    if (options.async) {
      return new Bifrost(options, originalOptions, jqXHR);
    }
  });

  $.ajaxSetup({
    converters: {
      'iframe text': function(content) {
        return content.find('body').text();
      },
      'iframe json': function(content) {
        return $.parseJSON(content.find('body').text());
      },
      'iframe html': function(content) {
        return content.find('body').html();
      },
      'iframe script': function(content) {
        return $.globalEval(content.find('body').text());
      },
      'iframe xml': function(content) {
        var ref, xmlDoc;
        xmlDoc = content[0];
        if ($.isXMLDoc(xmlDoc)) {
          return xmlDoc;
        }
        return $.parseXML(((ref = xmlDoc.XMLDocument) != null ? ref.xml : void 0) || content.find('body').html());
      }
    }
  });

}).call(this);
